searchNodes=[{"doc":"","ref":"Mix.Tasks.Compile.Temple.html","title":"Mix.Tasks.Compile.Temple","type":"task"},{"doc":"This task is useful for converting a ton of HTML into Temple syntax. Note about EEx and HEEx In the future, this should be able to convert EEx and HEEx as well, but that would involve invoking or forking their parsers. That is certainly doable, but is out of scope for what I needed right now. Contributions are welcome! Usage $ mix temple.convert some_file.html","ref":"Mix.Tasks.Temple.Convert.html","title":"Mix.Tasks.Temple.Convert","type":"task"},{"doc":"Temple syntax is available inside the temple , and is compiled into efficient Elixir code at compile time using the configured EEx.Engine . You should checkout the guides for a more in depth explanation. Usage defmodule MyApp.HomePage do import Temple def render ( ) do assigns = %{ title : &quot;My Site | Sign Up&quot; , logged_in : false } temple do &quot;&lt;!DOCTYPE html&gt;&quot; html do head do meta charset : &quot;utf-8&quot; meta http_equiv : &quot;X-UA-Compatible&quot; , content : &quot;IE=edge&quot; meta name : &quot;viewport&quot; , content : &quot;width=device-width, initial-scale=1.0&quot; link rel : &quot;stylesheet&quot; , href : &quot;/css/app.css&quot; title do : @title end body do header class : &quot;header&quot; do ul do li do a href : &quot;/&quot; , do : &quot;Home&quot; end li do if @logged_in do a href : &quot;/logout&quot; , do : &quot;Logout&quot; else a href : &quot;/login&quot; , do : &quot;Login&quot; end end end end main do &quot;Hi! Welcome to my website.&quot; end end end end end end Configuration Engine By default Temple wil use the EEx.SmartEngine , but you can configure it to use any other engine. Examples could be Phoenix.HTML.Engine or Phoenix.LiveView.Engine . config :temple , engine : Phoenix.HTML.Engine Aliases You can add an alias for an element if there is a namespace collision with a function. If you are using Phoenix.HTML , there will be namespace collisions with the &lt;link&gt; and &lt;label&gt; elements. config :temple , :aliases , label : :label_tag , link : :link_tag , select : :select_tag temple do label_tag do &quot;Email&quot; end link_tag href : &quot;/css/site.css&quot; end This will result in: &lt;label&gt; Email &lt;/label&gt; &lt;link href=&quot;/css/site.css&quot;&gt;","ref":"Temple.html","title":"Temple","type":"module"},{"doc":"","ref":"Temple.html#temple/1","title":"Temple.temple/1","type":"macro"},{"doc":"Use this module to create your own component implementation. This is only required if you are not using a component implementation from another framework, like Phoenix LiveView. At it's core, a component implmentation includes the following functions component/2 inner_block/2 render_slot/2 These functions are used by the template compiler, so you won't be calling them directly. Usage Invoke the __using__/1 macro to create your own module, and then import that module where you need to define define or use components (usually everywhere). We'll use an example that is similar to what Temple uses in its own test suite.. defmodule MyAppWeb.Component do use Temple.Component defmacro __using__ ( _ ) do quote do import Temple import unquote ( __MODULE__ ) end end end Then you can use your module when you want to define or use a component. defmodule MyAppWeb.Components do use MyAppWeb.Component def basic_component ( _assigns ) do temple do div do &quot;I am a basic component&quot; end end end end","ref":"Temple.Component.html","title":"Temple.Component","type":"module"},{"doc":"You are looking at the README for the main branch. The README for the latest stable release is located here . Temple Temple is an Elixir DSL for writing HTML and SVG.","ref":"readme.html","title":"README","type":"extras"},{"doc":"Add temple to your list of dependencies in mix.exs : def deps do [ { :temple , &quot;~&gt; 0.11.0&quot; } ] end","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"Currently Temple has the following things on which it won't compromise. Will only work with valid Elixir syntax. Should work in all web environments such as Plug, Aino, Phoenix, and Phoenix LiveView.","ref":"readme.html#goals","title":"README - Goals","type":"extras"},{"doc":"Using Temple is as simple as using the DSL inside of an temple/1 block. The runtime result of the macro is your HTML. See the guides for more details. import Temple temple do h2 do : &quot;todos&quot; ul class : &quot;list&quot; do for item &lt;- @items do li class : &quot;item&quot; do div class : &quot;checkbox&quot; do div class : &quot;bullet hidden&quot; end div do : item end end end script do : &quot;&quot;&quot; function toggleCheck({currentTarget}) { currentTarget.children[0].children[0].classList.toggle(&quot;hidden&quot;); } let items = document.querySelectorAll(&quot;li&quot;); Array.from(items).forEach(checkbox =&gt; checkbox.addEventListener(&quot;click&quot;, toggleCheck)); &quot;&quot;&quot; end Components Temple components are simple to write and easy to use. Unlike normal partials, Temple components have the concept of &quot;slots&quot;, which are similar Vue . You can also refer to HEEx and Surface for examples of templates that have the &quot;slot&quot; concept. Temple components are compatible with HEEx and Surface components and can be shared. Please see the guides for more details. defmodule MyAppWeb.Component do import Temple def card ( assigns ) do temple do section do div do slot @header end div do slot @inner_block end div do slot @footer end end end end end Using components is as simple as passing a reference to your component function to the c keyword. import MyAppWeb.Component c &amp; card / 1 do slot :header do @user . full_name end @user . bio slot :footer do a href : &quot;https://twitter.com/ \#{ @user . twitter } &quot; do &quot;@ \#{ @user . twitter } &quot; end a href : &quot;https://github.com/ \#{ @user . github } &quot; do &quot;@ \#{ @user . github } &quot; end end end Engine By default, Temple will use the EEx.SmartEngine that is built into the Elixir standard library. If you are a web framework that uses it's own template engine (such as Aino and Phoenix/LiveView, you can configure Temple to it! # config/config.exs config :temple , engine : Aino.View.Engine # or Phoenix.HTML.Engine or Phoenix.LiveView.Engine Formatter To include Temple's formatter configuration, add :temple to your .formatter.exs . [ import_deps : [ :temple ] , inputs : [ &quot;*.{ex,exs}&quot; , &quot;priv/*/seeds.exs&quot; , &quot;{config,lib,test}/**/*.{ex,exs,lexs}&quot; ] , ]","ref":"readme.html#usage","title":"README - Usage","type":"extras"},{"doc":"To use with Phoenix , please use the temple_phoenix package! This bundles up some useful helpers as well as the Phoenix Template engine.","ref":"readme.html#phoenix","title":"README - Phoenix","type":"extras"},{"doc":"Introducing Temple: An elegant HTML library for Elixir and Phoenix Temple, AST, and Protocols Thinking Elixir Episode 92: Temple with Mitchell Hanberg How EEx Turns Your Template Into HTML","ref":"readme.html#related","title":"README - Related","type":"extras"},{"doc":"","ref":"getting-started.html","title":"Getting Started","type":"extras"},{"doc":"Welcome! Temple is a HTML DSL for Elixir, let's get started! First, make sure you are using Elixir V1.13 or higher. Add :temple to your deps and run mix deps.get { :temple , &quot;~&gt; 0.9.0-rc.0&quot; } Now you must prepend the Temple compiler to your projects :compilers configuration in mix.exs . There is a chance that your project doesn't set this option at all, but don't worry, it's really easy to add! defmodule MyApp.MixProject do use Mix.Project def project do [ # ... compilers : [ :temple ] ++ Mix . compilers ( ) , # ... ] end # ... end All done, Now let's start building our app!","ref":"getting-started.html#install","title":"Getting Started - Install","type":"extras"},{"doc":"Temple works out of the box without any configuration, but here are a couple of conifg options that you could need to use. Engine By default, Temple uses the built in EEx.SmartEngine . If you want to use a different engine, this is as easy as setting the :engine configuration option. # config/config.exs config :temple , engine : Phoenix.HTML.Engine Aliases Temple code will reserve some local function calls for HTML tags. If you have a local function that you would like to use instead, you can create an alias for any tag. Common aliases for Phoenix projects look like this: config :temple , aliases : [ label : :label_tag , link : :link_tag , select : :select_tag , textarea : :textarea_tag ]","ref":"getting-started.html#configuration","title":"Getting Started - Configuration","type":"extras"},{"doc":"A Temple template is written inside of the Temple.temple/1 macro. Code inside there will be compiled into efficient Elixir code by the configured EEx engine. Local functions that have a corresponding HTML5 tag are reserved and will be used when generated your markup. Let's take a look at a basic form written with Temple. defmodule MyApp.FormExample do import Temple def form_page ( ) do assigns = %{ title : &quot;My Site | Sign Up&quot; , logged_in : false } temple do &quot;&lt;!DOCTYPE html&gt;&quot; html do head do meta charset : &quot;utf-8&quot; meta http_equiv : &quot;X-UA-Compatible&quot; , content : &quot;IE=edge&quot; meta name : &quot;viewport&quot; , content : &quot;width=device-width, initial-scale=1.0&quot; link rel : &quot;stylesheet&quot; , href : &quot;/css/app.css&quot; title do : @title end body do if @logged_in do header class : &quot;header&quot; do ul do li do a href : &quot;/&quot; , do : &quot;Home&quot; end li do a href : &quot;/logout&quot; , do : &quot;Logout&quot; end end end end form action : &quot;&quot; , method : &quot;get&quot; , class : &quot;form-example&quot; do div class : &quot;form-example&quot; do label for : &quot;name&quot; , do : &quot;Enter your name:&quot; input type : &quot;text&quot; , name : &quot;name&quot; , id : &quot;name&quot; , required : true end div class : &quot;form-example&quot; do label for : &quot;email&quot; , do : &quot;Enter your email:&quot; input type : &quot;email&quot; , name : &quot;email&quot; , id : &quot;email&quot; , required : true end div class : &quot;form-example&quot; do input type : &quot;submit&quot; , value : &quot;Subscribe!&quot; end end end end end end end This example showcases an entire HTML page made with Temple! Let's dive a little deeper everything we're seeing here. Through out this guide, you will see code that includes features that are explained later on. Feel free to skip ahead to read on, or just keep reading. It will all make sense eventually!","ref":"your-first-template.html","title":"Your First Template","type":"extras"},{"doc":"The text node is a basic building block of any HTML document. In Temple, text nodes are represented by Elixir string literals. The very first line of the previous example is our doc type, emitted into the final document with &quot;&lt;!DOCTYPE html&gt;&quot; . This is a text node and will be emitted into the document as-is. Note: String literals are emitted into text nodes. If you are using string interpolation with the \#{some_expression} syntax, that is treated as an expression and will be evaluated in whichever way the configured engine evaluates expression. By default, the EEx.SmartEngine doesn't do any escaping of expressions, so that could still be emitted as-is, or even as HTML to be interpreted by your web browser.","ref":"your-first-template.html#text-nodes","title":"Your First Template - Text Nodes","type":"extras"},{"doc":"Void tags are HTML5 tags that do not have children, meaning they are &quot;self closing&quot;. We can observe these in the previous example as the &lt;input&gt; tag. You'll note that the tag does not have a :do key or a do block.","ref":"your-first-template.html#void-tags","title":"Your First Template - Void Tags","type":"extras"},{"doc":"Non-void tags are HTML5 tags that do have children. You are probably most familiar with these type of tags, as they include the famous &lt;div&gt;&lt;/div&gt; and &lt;span&gt;&lt;/span&gt; . These tags can enclose their children nodes with either a do/end block or the inline :do keyword. Whitespace Nonvoid tags that use the do/end syntax will be emitted with internal whitespace. temple do div class : &quot;foo&quot; do # children end end ...will emit markup that looks like... &lt;div class=&quot;foo&quot;&gt; &lt;!-- children --&gt; &lt;/div&gt; Note: The Elixir comment will not be rendered into an HTML comment. This is just used in the example. (This does sound like a good feature though...) Nonvoid tags that use the :do keyword syntax will be emitted without internal whitespace. This allows you to correctly use the :empty CSS psuedo-selector in your stylesheet. temple do p class : &quot;alert alert-info&quot; , do : &quot;Your account was recently updated!&quot; end ...will emit markup that looks like... &lt;p class=&quot;alert alert-info&quot;&gt;Your account was recently updated!&lt;/p&gt;","ref":"your-first-template.html#non-void-tags","title":"Your First Template - Non-void Tags","type":"extras"},{"doc":"Temple leverages Phoenix.HTML.attributes_escape/1 internally, so you can refer to it's documentation for all of the details. Dynamic Attributes To render dynamic attributes into a tag, you can pass them with the reserved attribute :rest! . assigns = %{ data : [ data_foo : &quot;hi&quot; ] } temple do div id : &quot;foo&quot; , rest! : @data do &quot;Hello, world!&quot; end end will render to &lt;div id=&quot;foo&quot; data-foo=&quot;hi&quot;&gt; Hello, world! &lt;/div&gt;","ref":"your-first-template.html#attributes","title":"Your First Template - Attributes","type":"extras"},{"doc":"Any Elixir expression can be used anywhere inside of a Temple template. Here are a few examples. temple do h2 do : &quot;Members&quot; ul do for member &lt;- @members do li do : member end end end Match Expressions Match expression are handled slightly differently. Generally if you are assigning an expression to a variable (a match), you are going to use that binding later and do not want to emit it into the document. So, match expressions are not emitted into the document. They are functionally equivalent to the &lt;% .. %. syntax of EEx . The expression is evaluated, but not included in the rendered document. Typically you should not be writing this type of expression inside of your template, but if you wanted to declare an alias, you would need to write the following to not emit the alias into the document. temple do _ = alias My.Deep.Module div do Module . func ( ) end end","ref":"your-first-template.html#elixir-expressions","title":"Your First Template - Elixir Expressions","type":"extras"},{"doc":"Since Temple uses the EEx.SmartEngine by default, you are able to use the assigns feature. The assigns feature allows you to ergonomically access the members of a assigns variable by the @ macro. The assign variable just needs to exist within the scope of the template (the same as a normal EEx template that uses EEx.SmartEngine ), it can be a function parameter or created inside the function. def card ( assigns ) do temple do div class : &quot;card&quot; do section class : &quot;card-header&quot; do @name end section class : &quot;card-body&quot; do @bio end if Enum . any? ( @socials ) do section class : &quot;card-footer&quot; do for social &lt;- @socials do a href : social . link do social . name end end end end end end end","ref":"your-first-template.html#assigns","title":"Your First Template - Assigns","type":"extras"},{"doc":"Temple has the concept of components, which allow you an expressive and composable way to break up your templates into re-usable chunks. A component is any arity-1 function that take an argument called assigns and returns the result of the Temple.temple/1 macro.","ref":"components.html","title":"Components","type":"extras"},{"doc":"Here is an example of a simple Temple component. You can observe that it seems very similar to a regular Temple template, and that is because it is a regular template! defmodule MyApp.Components do import Temple def button ( assigns ) do temple do button type : &quot;button&quot; , class : &quot;bg-blue-800 text-white rounded \#{ @class } &quot; do @text end end end end","ref":"components.html#definition","title":"Components - Definition","type":"extras"},{"doc":"To use a component, you will use the special c keyword. This is called a &quot;keyword&quot; because it is not a function or macro, but only exists inside of the Temple.temple/1 block. The first argument will be the function reference to your component function, followed by any assigns. You can pass dynamic assigns using the :rest! keyword the same way you would with a normal tag. defmodule MyApp.ConfirmDialog do import Temple import MyApp.Components def render ( assigns ) do temple do dialog open : true do p do : &quot;Are you sure?&quot; form method : &quot;dialog&quot; do c &amp; button / 1 , class : &quot;border border-white&quot; , text : &quot;Yes&quot; end end end end end","ref":"components.html#usage","title":"Components - Usage","type":"extras"},{"doc":"Temple components can take &quot;slots&quot; as well. This is the method for providing dynamic content from the call site into the component. Slots are defined and rendered using the slot keyword. This is similar to the c keyword, in that it is not defined using a function or macro. Default Slot The default slot can be rendered from within your component by passing the slot the @inner_block assign. Let's redefine our button component using slots. defmodule MyApp.Components do import Temple def button ( assigns ) do temple do button type : &quot;button&quot; , class : &quot;bg-blue-800 text-white rounded \#{ @class } &quot; do slot @inner_block end end end end You can pass content through the &quot;default&quot; slot of your component simply by passing a do/end block to your component at the call site. This is a special case for the default slot. defmodule MyApp.ConfirmDialog do import Temple import MyApp.Components def render ( assigns ) do temple do dialog open : true do p do : &quot;Are you sure?&quot; form method : &quot;dialog&quot; do c &amp; button / 1 , class : &quot;border border-white&quot; do &quot;Yes&quot; end end end end end end Named Slots You can also define a &quot;named&quot; slot, which allows you to pass more than one set of dynamic content to your component. We'll use a &quot;card&quot; example to illustrate this. This example is adapted from the Surface documentation on slots. Definition defmodule MyApp.Components do import Temple def card ( assigns ) do temple do div class : &quot;card&quot; do header class : &quot;card-header&quot; , style : &quot;background-color: @f5f5f5&quot; do p class : &quot;card-header-title&quot; do slot @header end end div class : &quot;card-content&quot; do div class : &quot;content&quot; do slot @inner_block end end footer class : &quot;card-footer&quot; , style : &quot;background-color: #f5f5f5&quot; do slot @footer end end end end end Usage def MyApp.CardExample do import Temple import MyApp.Components def render ( assigns ) do temple do c &amp; card / 1 do slot :header do &quot;A simple card component&quot; end &quot;This example demonstrates how to create components with multiple, named slots&quot; slot :footer do a href : &quot;#&quot; , class : &quot;card-footer-item&quot; , do : &quot;Footer Item 1&quot; a href : &quot;#&quot; , class : &quot;card-footer-item&quot; , do : &quot;Footer Item 2&quot; end end end end end","ref":"components.html#slots","title":"Components - Slots","type":"extras"},{"doc":"Sometimes it is necessary to pass data into a slot (hereby known as slot attributes ) from the call site and from a component definition (hereby known as slot arguments ) back to the call site. Dynamic slot attributes can be passed using the :rest! attribute in the same way you can with tag attributes. Let's look at what a table component could look like. Here we observe we access an attribute in the slot in the header with col.label . This example is taken from the HEEx documentation to demonstrate how you can build the same thing with Temple. Note: Slot attributes can only be accessed on an individual slot, so if you define a single slot definition, you still need to loop through it to access it, as they are stored as a list. Definition defmodule MyApp.Components do import Temple def table ( assigns ) do temple do table do thead do tr do for col &lt;- @col do th do : col . label # 👈 accessing a slot attribute end end end tbody do for row &lt;- @rows do tr do for col &lt;- @col do td do slot col , row end end end end end end end end end Usage When we render the slot, we can pattern match on the data passed through the slot via the :let attribute. def MyApp.TableExample do import Temple import MyApp.Componens def render ( assigns ) do temple do section do h2 do : &quot;Users&quot; c &amp; table / 1 , rows : @users do # 👇 defining the parameter for the slot argument slot :col , let! : user , label : &quot;Name&quot; do # 👈 passing a slot attribute user . name end slot :col , let! : user , label : &quot;Address&quot; do user . address end end end end end end","ref":"components.html#passing-data-to-and-through-slots","title":"Components - Passing data to and through Slots","type":"extras"},{"doc":"If you want to use something like TailwindUI with Temple, you're going to have to convert a ton of vanilla HTML into Temple syntax. Luckily, Temple provides a mix task for converting an HTML file into Temple syntax and writes it to stdout.","ref":"converting-html.html","title":"Converting HTML","type":"extras"},{"doc":"First, we would want to create a temporary HTML file with the HTML we'd like to convert. Hint The following examples use the pbpaste and pbcopy utilities found on macOS. These are used to send your clipboard contents into stdout and put stdout into your clipboard. $ pbpaste &gt; temp.html Then, we can convert that file and copy the output into our clipboard. $ mix temple.convert temp.html | pbcopy Now, you are free to paste the new temple syntax into your project!","ref":"converting-html.html#usage","title":"Converting HTML - Usage","type":"extras"},{"doc":"First off, Temple now requires Elixir 1.13 or higher. This is because of some changes that were brought to the Elixir parser.","ref":"0-8-to-0-9.html","title":"Migrating from 0.8 to 0.9","type":"extras"},{"doc":"To control whitespace in an element, Temple will now control this based on whether the do was used in the keyword list syntax or the do/end syntax. In 0.8, you would do: span do &quot;hello!&quot; end # &lt;span&gt; # hello! # &lt;/span&gt; # The ! version of the element would render it as &quot;tight&quot; span! do &quot;hello!&quot; end # &lt;span&gt;hello!&lt;/span&gt; In 0.9, you would do: span do &quot;hello!&quot; end # &lt;span&gt; # hello! # &lt;/span&gt; span do : &quot;hello!&quot; # &lt;span&gt;hello!&lt;/span&gt;","ref":"0-8-to-0-9.html#whitespace-control","title":"Migrating from 0.8 to 0.9 - Whitespace Control","type":"extras"},{"doc":"Components are no longer module based. To render a component, you can pass a function reference to the c keyword. You also no longer need to define a component in a module, using the Temple.Component module and its render macro. In 0.8, you would define a component like: defmodule MyAppWeb.Component.Card do import Temple.Component render do div class : &quot;border p-4 rounded&quot; do slot :default end end end And you would use the component like: div do c MyAppWeb.Component.Card do &quot;Welcome to my app!&quot; end end In 0.9, you would define a component like: defmodule MyAppWeb.Components do import Temple def card ( assigns ) do temple do div class : &quot;border p-4 rounded&quot; do slot :default end end end end And you would use the component like: div do c &amp; MyAppWeb.Components . card / 1 do &quot;Welcome to my app!&quot; end end We can observe here that in 0.9 the component is just any 1-arity function, so you can define them anywhere and you can have more than 1 in a single module. defcomp Now that components are just functions, you no longer need this special macro to define a component in the middle of the module. This can simply be converted to a function.","ref":"0-8-to-0-9.html#components","title":"Migrating from 0.8 to 0.9 - Components","type":"extras"},{"doc":"All Phoenix related items have moved to the temple_phoenix package. Please see that library docs for more details.","ref":"0-8-to-0-9.html#phoenix","title":"Migrating from 0.8 to 0.9 - Phoenix","type":"extras"},{"doc":"Most of the changes in this release are related to tweaking Temple's component model to align with HEEx &amp; Surface.","ref":"0-10-to-0-11.html","title":"Migrating from 0.10 to 0.11","type":"extras"},{"doc":"Slots are now available as assigns in the component and are rendered as such. Before def my_component ( assign ) do temple do span do slot :a_slot end end end After def my_component ( assign ) do temple do span do slot @a_slot end end end","ref":"0-10-to-0-11.html#rendering-slots","title":"Migrating from 0.10 to 0.11 - Rendering Slots","type":"extras"},{"doc":"The main body of a component has been renamed from :default to :inner_block . Note: The &quot;after&quot; example also includes the necessary change specified above. Before def my_component ( assign ) do temple do span do slot :default end end end After def my_component ( assign ) do temple do span do slot @inner_block end end end","ref":"0-10-to-0-11.html#default-slot-has-been-renamed-to-inner_block","title":"Migrating from 0.10 to 0.11 - :default slot has been renamed to :inner_block","type":"extras"},{"doc":"The syntax for capturing data being passed from the call site of a slot to the definition of a slot (or put another way, from the definition of a component to the call site of the component) has changed. You now capture it as the value of the :let! attribute on the slot definition. Before def my_component ( assign ) do temple do c &amp; my_component / 1 do slot :a_slot , %{ some : value } do &quot;I&#39;m using some \#{ value } &quot; end end end end After def my_component ( assign ) do temple do c &amp; my_component / 1 do slot :a_slot , let! : %{ some : value } do &quot;I&#39;m using some \#{ value } &quot; end end end end","ref":"0-10-to-0-11.html#passing-data-into-slots","title":"Migrating from 0.10 to 0.11 - Passing data into slots","type":"extras"}]